"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file

Copyright 2020-2020 Exactpro (Exactpro Systems Limited)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""
import builtins
import collections.abc
import google.protobuf.any_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import google.protobuf.wrappers_pb2
import sys
import th2_grpc_common.common_pb2
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _FilterParameterType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _FilterParameterTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_FilterParameterType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    NUMBER: _FilterParameterType.ValueType  # 0
    BOOLEAN: _FilterParameterType.ValueType  # 1
    STRING: _FilterParameterType.ValueType  # 2
    STRING_LIST: _FilterParameterType.ValueType  # 3

class FilterParameterType(_FilterParameterType, metaclass=_FilterParameterTypeEnumTypeWrapper):
    """Filtering data types"""

NUMBER: FilterParameterType.ValueType  # 0
BOOLEAN: FilterParameterType.ValueType  # 1
STRING: FilterParameterType.ValueType  # 2
STRING_LIST: FilterParameterType.ValueType  # 3
global___FilterParameterType = FilterParameterType

class _TimeRelation:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _TimeRelationEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_TimeRelation.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    NEXT: _TimeRelation.ValueType  # 0
    PREVIOUS: _TimeRelation.ValueType  # 1

class TimeRelation(_TimeRelation, metaclass=_TimeRelationEnumTypeWrapper): ...

NEXT: TimeRelation.ValueType  # 0
PREVIOUS: TimeRelation.ValueType  # 1
global___TimeRelation = TimeRelation

@typing_extensions.final
class EventData(google.protobuf.message.Message):
    """Full event data"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EVENT_ID_FIELD_NUMBER: builtins.int
    PARENT_EVENT_ID_FIELD_NUMBER: builtins.int
    BATCH_ID_FIELD_NUMBER: builtins.int
    IS_BATCHED_FIELD_NUMBER: builtins.int
    START_TIMESTAMP_FIELD_NUMBER: builtins.int
    END_TIMESTAMP_FIELD_NUMBER: builtins.int
    SUCCESSFUL_FIELD_NUMBER: builtins.int
    EVENT_NAME_FIELD_NUMBER: builtins.int
    EVENT_TYPE_FIELD_NUMBER: builtins.int
    BODY_FIELD_NUMBER: builtins.int
    ATTACHED_MESSAGE_IDS_FIELD_NUMBER: builtins.int
    @property
    def event_id(self) -> th2_grpc_common.common_pb2.EventID:
        """Current event id"""
    @property
    def parent_event_id(self) -> th2_grpc_common.common_pb2.EventID:
        """Event id of a parent event. It is absent for root event"""
    @property
    def batch_id(self) -> th2_grpc_common.common_pb2.EventID:
        """Event id of a parent event. It is absent for root event"""
    is_batched: builtins.bool
    """Flag indicating that the event is in batch"""
    @property
    def start_timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    @property
    def end_timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """May be absent."""
    successful: th2_grpc_common.common_pb2.EventStatus.ValueType
    """Aggregated status of current and children events which sync written."""
    event_name: builtins.str
    event_type: builtins.str
    """May be absent."""
    body: builtins.bytes
    """May be absent."""
    @property
    def attached_message_ids(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[th2_grpc_common.common_pb2.MessageID]:
        """id of messages depending on this event"""
    def __init__(
        self,
        *,
        event_id: th2_grpc_common.common_pb2.EventID | None = ...,
        parent_event_id: th2_grpc_common.common_pb2.EventID | None = ...,
        batch_id: th2_grpc_common.common_pb2.EventID | None = ...,
        is_batched: builtins.bool = ...,
        start_timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        end_timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        successful: th2_grpc_common.common_pb2.EventStatus.ValueType = ...,
        event_name: builtins.str = ...,
        event_type: builtins.str = ...,
        body: builtins.bytes = ...,
        attached_message_ids: collections.abc.Iterable[th2_grpc_common.common_pb2.MessageID] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["batch_id", b"batch_id", "end_timestamp", b"end_timestamp", "event_id", b"event_id", "parent_event_id", b"parent_event_id", "start_timestamp", b"start_timestamp"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["attached_message_ids", b"attached_message_ids", "batch_id", b"batch_id", "body", b"body", "end_timestamp", b"end_timestamp", "event_id", b"event_id", "event_name", b"event_name", "event_type", b"event_type", "is_batched", b"is_batched", "parent_event_id", b"parent_event_id", "start_timestamp", b"start_timestamp", "successful", b"successful"]) -> None: ...

global___EventData = EventData

@typing_extensions.final
class EventMetadata(google.protobuf.message.Message):
    """Event metadata"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EVENT_ID_FIELD_NUMBER: builtins.int
    PARENT_EVENT_ID_FIELD_NUMBER: builtins.int
    START_TIMESTAMP_FIELD_NUMBER: builtins.int
    SUCCESSFUL_FIELD_NUMBER: builtins.int
    EVENT_NAME_FIELD_NUMBER: builtins.int
    EVENT_TYPE_FIELD_NUMBER: builtins.int
    @property
    def event_id(self) -> th2_grpc_common.common_pb2.EventID:
        """Current event id"""
    @property
    def parent_event_id(self) -> th2_grpc_common.common_pb2.EventID:
        """Event id of a parent event. It is absent for root event"""
    @property
    def start_timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    successful: th2_grpc_common.common_pb2.EventStatus.ValueType
    """Aggregated status of current and children events which sync written."""
    event_name: builtins.str
    event_type: builtins.str
    def __init__(
        self,
        *,
        event_id: th2_grpc_common.common_pb2.EventID | None = ...,
        parent_event_id: th2_grpc_common.common_pb2.EventID | None = ...,
        start_timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        successful: th2_grpc_common.common_pb2.EventStatus.ValueType = ...,
        event_name: builtins.str = ...,
        event_type: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["event_id", b"event_id", "parent_event_id", b"parent_event_id", "start_timestamp", b"start_timestamp"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["event_id", b"event_id", "event_name", b"event_name", "event_type", b"event_type", "parent_event_id", b"parent_event_id", "start_timestamp", b"start_timestamp", "successful", b"successful"]) -> None: ...

global___EventMetadata = EventMetadata

@typing_extensions.final
class EventIds(google.protobuf.message.Message):
    """List of event ids"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    IDS_FIELD_NUMBER: builtins.int
    @property
    def ids(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[th2_grpc_common.common_pb2.EventID]: ...
    def __init__(
        self,
        *,
        ids: collections.abc.Iterable[th2_grpc_common.common_pb2.EventID] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["ids", b"ids"]) -> None: ...

global___EventIds = EventIds

@typing_extensions.final
class Events(google.protobuf.message.Message):
    """List of event data"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EVENTS_FIELD_NUMBER: builtins.int
    @property
    def events(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EventData]: ...
    def __init__(
        self,
        *,
        events: collections.abc.Iterable[global___EventData] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["events", b"events"]) -> None: ...

global___Events = Events

@typing_extensions.final
class MessageData(google.protobuf.message.Message):
    """Full event data"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MESSAGE_ID_FIELD_NUMBER: builtins.int
    SESSION_ID_FIELD_NUMBER: builtins.int
    DIRECTION_FIELD_NUMBER: builtins.int
    TIMESTAMP_FIELD_NUMBER: builtins.int
    MESSAGE_TYPE_FIELD_NUMBER: builtins.int
    BODY_FIELD_NUMBER: builtins.int
    BODY_BASE64_FIELD_NUMBER: builtins.int
    ATTACHED_EVENT_IDS_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    @property
    def message_id(self) -> th2_grpc_common.common_pb2.MessageID:
        """Message id should be unique in session"""
    @property
    def session_id(self) -> th2_grpc_common.common_pb2.ConnectionID:
        """Session alias"""
    direction: th2_grpc_common.common_pb2.Direction.ValueType
    """Transport direction."""
    @property
    def timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Message creation timestamp"""
    message_type: builtins.str
    """Message type by dictionary"""
    body: builtins.str
    """May be absent."""
    body_base64: builtins.str
    """May be absent."""
    @property
    def attached_event_ids(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[th2_grpc_common.common_pb2.EventID]:
        """id of events depending on this message"""
    @property
    def message(self) -> th2_grpc_common.common_pb2.Message:
        """May be absent."""
    def __init__(
        self,
        *,
        message_id: th2_grpc_common.common_pb2.MessageID | None = ...,
        session_id: th2_grpc_common.common_pb2.ConnectionID | None = ...,
        direction: th2_grpc_common.common_pb2.Direction.ValueType = ...,
        timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        message_type: builtins.str = ...,
        body: builtins.str = ...,
        body_base64: builtins.str = ...,
        attached_event_ids: collections.abc.Iterable[th2_grpc_common.common_pb2.EventID] | None = ...,
        message: th2_grpc_common.common_pb2.Message | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["message", b"message", "message_id", b"message_id", "session_id", b"session_id", "timestamp", b"timestamp"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["attached_event_ids", b"attached_event_ids", "body", b"body", "body_base64", b"body_base64", "direction", b"direction", "message", b"message", "message_id", b"message_id", "message_type", b"message_type", "session_id", b"session_id", "timestamp", b"timestamp"]) -> None: ...

global___MessageData = MessageData

@typing_extensions.final
class LastScannedObjectInfo(google.protobuf.message.Message):
    """Message and last scanned object. With a certain frequency (this can be configured in the configuration options),

    it is sent along with the elements found when searching via searchMessages
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    TIMESTAMP_MILLIS_FIELD_NUMBER: builtins.int
    SCAN_COUNTER_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Id of last scanned message or event"""
    timestamp_millis: builtins.int
    """Timestamp of message or event"""
    scan_counter: builtins.int
    """Number of objects already scanned"""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        timestamp_millis: builtins.int = ...,
        scan_counter: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id", "scan_counter", b"scan_counter", "timestamp_millis", b"timestamp_millis"]) -> None: ...

global___LastScannedObjectInfo = LastScannedObjectInfo

@typing_extensions.final
class StringList(google.protobuf.message.Message):
    """List of strings"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LIST_STRING_FIELD_NUMBER: builtins.int
    @property
    def list_string(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]: ...
    def __init__(
        self,
        *,
        list_string: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["list_string", b"list_string"]) -> None: ...

global___StringList = StringList

@typing_extensions.final
class IsMatched(google.protobuf.message.Message):
    """Response of match request"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    IS_MATCHED_FIELD_NUMBER: builtins.int
    is_matched: builtins.bool
    def __init__(
        self,
        *,
        is_matched: builtins.bool = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["is_matched", b"is_matched"]) -> None: ...

global___IsMatched = IsMatched

@typing_extensions.final
class FilterName(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FILTER_NAME_FIELD_NUMBER: builtins.int
    filter_name: builtins.str
    def __init__(
        self,
        *,
        filter_name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["filter_name", b"filter_name"]) -> None: ...

global___FilterName = FilterName

@typing_extensions.final
class ListFilterName(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FILTER_NAMES_FIELD_NUMBER: builtins.int
    @property
    def filter_names(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___FilterName]: ...
    def __init__(
        self,
        *,
        filter_names: collections.abc.Iterable[global___FilterName] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["filter_names", b"filter_names"]) -> None: ...

global___ListFilterName = ListFilterName

@typing_extensions.final
class Parameter(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    DEFAULT_VALUE_FIELD_NUMBER: builtins.int
    HINT_FIELD_NUMBER: builtins.int
    name: builtins.str
    type: global___FilterParameterType.ValueType
    @property
    def default_value(self) -> google.protobuf.any_pb2.Any: ...
    hint: builtins.str
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        type: global___FilterParameterType.ValueType = ...,
        default_value: google.protobuf.any_pb2.Any | None = ...,
        hint: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["default_value", b"default_value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["default_value", b"default_value", "hint", b"hint", "name", b"name", "type", b"type"]) -> None: ...

global___Parameter = Parameter

@typing_extensions.final
class FilterInfo(google.protobuf.message.Message):
    """Complete information about a specific filter"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    HINT_FIELD_NUMBER: builtins.int
    PARAMETERS_FIELD_NUMBER: builtins.int
    @property
    def name(self) -> global___FilterName: ...
    hint: builtins.str
    @property
    def parameters(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Parameter]: ...
    def __init__(
        self,
        *,
        name: global___FilterName | None = ...,
        hint: builtins.str = ...,
        parameters: collections.abc.Iterable[global___Parameter] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["name", b"name"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["hint", b"hint", "name", b"name", "parameters", b"parameters"]) -> None: ...

global___FilterInfo = FilterInfo

@typing_extensions.final
class Filter(google.protobuf.message.Message):
    """A filter object passed in a message or an event search request"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    NEGATIVE_FIELD_NUMBER: builtins.int
    VALUES_FIELD_NUMBER: builtins.int
    CONJUNCT_FIELD_NUMBER: builtins.int
    @property
    def name(self) -> global___FilterName: ...
    @property
    def negative(self) -> google.protobuf.wrappers_pb2.BoolValue: ...
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]: ...
    @property
    def conjunct(self) -> google.protobuf.wrappers_pb2.BoolValue: ...
    def __init__(
        self,
        *,
        name: global___FilterName | None = ...,
        negative: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        values: collections.abc.Iterable[builtins.str] | None = ...,
        conjunct: google.protobuf.wrappers_pb2.BoolValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["conjunct", b"conjunct", "name", b"name", "negative", b"negative"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["conjunct", b"conjunct", "name", b"name", "negative", b"negative", "values", b"values"]) -> None: ...

global___Filter = Filter

@typing_extensions.final
class Stream(google.protobuf.message.Message):
    """The object containing the data of the last message in the stream on which
    the search stopped, it is necessary to continue the search from the same place
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SESSION_FIELD_NUMBER: builtins.int
    DIRECTION_FIELD_NUMBER: builtins.int
    LAST_ID_FIELD_NUMBER: builtins.int
    session: builtins.str
    direction: th2_grpc_common.common_pb2.Direction.ValueType
    @property
    def last_id(self) -> th2_grpc_common.common_pb2.MessageID:
        """May be absent if there are no more messages in the stream with the specified session and direction"""
    def __init__(
        self,
        *,
        session: builtins.str = ...,
        direction: th2_grpc_common.common_pb2.Direction.ValueType = ...,
        last_id: th2_grpc_common.common_pb2.MessageID | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["last_id", b"last_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["direction", b"direction", "last_id", b"last_id", "session", b"session"]) -> None: ...

global___Stream = Stream

@typing_extensions.final
class StreamsInfo(google.protobuf.message.Message):
    """List of Stream objects containing information about all the streams"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    STREAMS_FIELD_NUMBER: builtins.int
    @property
    def streams(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Stream]: ...
    def __init__(
        self,
        *,
        streams: collections.abc.Iterable[global___Stream] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["streams", b"streams"]) -> None: ...

global___StreamsInfo = StreamsInfo

@typing_extensions.final
class MatchRequest(google.protobuf.message.Message):
    """Checks that an event or a message with the specified id is matched by the filters"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EVENT_ID_FIELD_NUMBER: builtins.int
    MESSAGE_ID_FIELD_NUMBER: builtins.int
    FILTERS_FIELD_NUMBER: builtins.int
    @property
    def event_id(self) -> th2_grpc_common.common_pb2.EventID: ...
    @property
    def message_id(self) -> th2_grpc_common.common_pb2.MessageID: ...
    @property
    def filters(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Filter]: ...
    def __init__(
        self,
        *,
        event_id: th2_grpc_common.common_pb2.EventID | None = ...,
        message_id: th2_grpc_common.common_pb2.MessageID | None = ...,
        filters: collections.abc.Iterable[global___Filter] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["event_id", b"event_id", "id", b"id", "message_id", b"message_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["event_id", b"event_id", "filters", b"filters", "id", b"id", "message_id", b"message_id"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["id", b"id"]) -> typing_extensions.Literal["event_id", "message_id"] | None: ...

global___MatchRequest = MatchRequest

@typing_extensions.final
class EventSearchRequest(google.protobuf.message.Message):
    """Event search request"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    START_TIMESTAMP_FIELD_NUMBER: builtins.int
    END_TIMESTAMP_FIELD_NUMBER: builtins.int
    PARENT_EVENT_FIELD_NUMBER: builtins.int
    SEARCH_DIRECTION_FIELD_NUMBER: builtins.int
    RESUME_FROM_ID_FIELD_NUMBER: builtins.int
    RESULT_COUNT_LIMIT_FIELD_NUMBER: builtins.int
    KEEP_OPEN_FIELD_NUMBER: builtins.int
    LIMIT_FOR_PARENT_FIELD_NUMBER: builtins.int
    METADATA_ONLY_FIELD_NUMBER: builtins.int
    ATTACHED_MESSAGES_FIELD_NUMBER: builtins.int
    FILTERS_FIELD_NUMBER: builtins.int
    @property
    def start_timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """unix timestamp - Sets the search starting point. One of the 'start_timestamp' or 'resume_from_id' must not absent"""
    @property
    def end_timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """unix timestamp - Sets the timestamp to which the search will be performed, starting with 'start_timestamp'. When 'search_direction' is previous, end_timestamp must be less than start_timestamp. By default it is absent (the search is carried out endlessly into the past or into the future)."""
    @property
    def parent_event(self) -> th2_grpc_common.common_pb2.EventID:
        """Will match events with the specified parent element."""
    search_direction: global___TimeRelation.ValueType
    """Sets the lookup direction. Can be used for pagination. Set by default to NEXT."""
    @property
    def resume_from_id(self) -> th2_grpc_common.common_pb2.EventID:
        """last event id. In order to continue the execution of an interrupted sse request, you need to send exactly the same request with an indication of the element ID, from which the data transfer will be resumed. By default it is absent. One of the 'start_timestamp' or 'resume_from_id' must not absent"""
    @property
    def result_count_limit(self) -> google.protobuf.wrappers_pb2.Int32Value:
        """Sets the maximum amount of events to return. By default it is absent (unlimited)."""
    @property
    def keep_open(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """If the search has reached the current moment, it is necessary to wait further for the appearance of new data. Set to false by default."""
    @property
    def limit_for_parent(self) -> google.protobuf.wrappers_pb2.Int64Value:
        """How many children events for each parent do we want to request. By default it is absent (unlimited)."""
    @property
    def metadata_only(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """ Receive only metadata (true) or entire event (false) (without attachedMessageIds). Set by default to true."""
    @property
    def attached_messages(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """If the metadataOnly is false, it will additionally load attachedMessageIds. Set by default to false."""
    @property
    def filters(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Filter]:
        """List of event search filters. (See 'search/sse/events' HTTP method https://github.com/th2-net/th2-rpt-data-provider)"""
    def __init__(
        self,
        *,
        start_timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        end_timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        parent_event: th2_grpc_common.common_pb2.EventID | None = ...,
        search_direction: global___TimeRelation.ValueType = ...,
        resume_from_id: th2_grpc_common.common_pb2.EventID | None = ...,
        result_count_limit: google.protobuf.wrappers_pb2.Int32Value | None = ...,
        keep_open: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        limit_for_parent: google.protobuf.wrappers_pb2.Int64Value | None = ...,
        metadata_only: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        attached_messages: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        filters: collections.abc.Iterable[global___Filter] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["attached_messages", b"attached_messages", "end_timestamp", b"end_timestamp", "keep_open", b"keep_open", "limit_for_parent", b"limit_for_parent", "metadata_only", b"metadata_only", "parent_event", b"parent_event", "result_count_limit", b"result_count_limit", "resume_from_id", b"resume_from_id", "start_timestamp", b"start_timestamp"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["attached_messages", b"attached_messages", "end_timestamp", b"end_timestamp", "filters", b"filters", "keep_open", b"keep_open", "limit_for_parent", b"limit_for_parent", "metadata_only", b"metadata_only", "parent_event", b"parent_event", "result_count_limit", b"result_count_limit", "resume_from_id", b"resume_from_id", "search_direction", b"search_direction", "start_timestamp", b"start_timestamp"]) -> None: ...

global___EventSearchRequest = EventSearchRequest

@typing_extensions.final
class MessageSearchRequest(google.protobuf.message.Message):
    """Message search request"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    START_TIMESTAMP_FIELD_NUMBER: builtins.int
    END_TIMESTAMP_FIELD_NUMBER: builtins.int
    RESUME_FROM_ID_FIELD_NUMBER: builtins.int
    SEARCH_DIRECTION_FIELD_NUMBER: builtins.int
    RESULT_COUNT_LIMIT_FIELD_NUMBER: builtins.int
    STREAM_FIELD_NUMBER: builtins.int
    KEEP_OPEN_FIELD_NUMBER: builtins.int
    MESSAGE_ID_FIELD_NUMBER: builtins.int
    ATTACHED_EVENTS_FIELD_NUMBER: builtins.int
    FILTERS_FIELD_NUMBER: builtins.int
    @property
    def start_timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """unix timestamp - Sets the search starting point. One of the 'start_timestamp' or 'resume_from_id' or 'message_id' must not absent"""
    @property
    def end_timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """unix timestamp - Sets the timestamp to which the search will be performed, starting with 'start_timestamp'. When search_direction is 'previous', 'end_timestamp' must be less than 'start_timestamp'. By default it is absent (the search is carried out endlessly into the past or into the future)."""
    @property
    def resume_from_id(self) -> th2_grpc_common.common_pb2.MessageID:
        """last message id. In order to continue the execution of an interrupted search request, you need to send exactly the same request with an indication of the element ID, from which the data transfer will be resumed.  By default it is absent. One of the 'start_timestamp' or 'resume_fromId' or 'message_id' must not absent"""
    search_direction: global___TimeRelation.ValueType
    """Sets the lookup direction. Can be used for pagination. Set by default to NEXT."""
    @property
    def result_count_limit(self) -> google.protobuf.wrappers_pb2.Int32Value:
        """Sets the maximum amount of messages to return. By default it is absent (unlimited)"""
    @property
    def stream(self) -> global___StringList:
        """Sets the stream ids to search in. Case-sensitive. Required."""
    @property
    def keep_open(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """ If the search has reached the current moment, it is necessary to wait further for the appearance of new data. Set by default to false."""
    @property
    def message_id(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[th2_grpc_common.common_pb2.MessageID]:
        """List of message IDs to restore the search. If given, it has the highest priority and ignores 'stream' (uses streams from the ids), 'start_timestamp' and 'resume_fromId'. By default it is absent."""
    @property
    def attached_events(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """If true, it will additionally load attachedEventsIds. Set by default to false."""
    @property
    def filters(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Filter]:
        """List of message search filters. (See 'search/sse/message' HTTP method https://github.com/th2-net/th2-rpt-data-provider)"""
    def __init__(
        self,
        *,
        start_timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        end_timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        resume_from_id: th2_grpc_common.common_pb2.MessageID | None = ...,
        search_direction: global___TimeRelation.ValueType = ...,
        result_count_limit: google.protobuf.wrappers_pb2.Int32Value | None = ...,
        stream: global___StringList | None = ...,
        keep_open: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        message_id: collections.abc.Iterable[th2_grpc_common.common_pb2.MessageID] | None = ...,
        attached_events: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        filters: collections.abc.Iterable[global___Filter] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["attached_events", b"attached_events", "end_timestamp", b"end_timestamp", "keep_open", b"keep_open", "result_count_limit", b"result_count_limit", "resume_from_id", b"resume_from_id", "start_timestamp", b"start_timestamp", "stream", b"stream"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["attached_events", b"attached_events", "end_timestamp", b"end_timestamp", "filters", b"filters", "keep_open", b"keep_open", "message_id", b"message_id", "result_count_limit", b"result_count_limit", "resume_from_id", b"resume_from_id", "search_direction", b"search_direction", "start_timestamp", b"start_timestamp", "stream", b"stream"]) -> None: ...

global___MessageSearchRequest = MessageSearchRequest

@typing_extensions.final
class StreamResponse(google.protobuf.message.Message):
    """The object returned by the search function (searchMessages/searchEvents)"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EVENT_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    EVENT_METADATA_FIELD_NUMBER: builtins.int
    LAST_SCANNED_OBJECT_FIELD_NUMBER: builtins.int
    STREAM_INFO_FIELD_NUMBER: builtins.int
    @property
    def event(self) -> global___EventData: ...
    @property
    def message(self) -> global___MessageData: ...
    @property
    def event_metadata(self) -> global___EventMetadata: ...
    @property
    def last_scanned_object(self) -> global___LastScannedObjectInfo: ...
    @property
    def stream_info(self) -> global___StreamsInfo: ...
    def __init__(
        self,
        *,
        event: global___EventData | None = ...,
        message: global___MessageData | None = ...,
        event_metadata: global___EventMetadata | None = ...,
        last_scanned_object: global___LastScannedObjectInfo | None = ...,
        stream_info: global___StreamsInfo | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["data", b"data", "event", b"event", "event_metadata", b"event_metadata", "last_scanned_object", b"last_scanned_object", "message", b"message", "stream_info", b"stream_info"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["data", b"data", "event", b"event", "event_metadata", b"event_metadata", "last_scanned_object", b"last_scanned_object", "message", b"message", "stream_info", b"stream_info"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["data", b"data"]) -> typing_extensions.Literal["event", "message", "event_metadata", "last_scanned_object", "stream_info"] | None: ...

global___StreamResponse = StreamResponse
